Index: frontends/php/include/hosts.inc.php
===================================================================
--- frontends/php/include/hosts.inc.php	(revision 38884)
+++ frontends/php/include/hosts.inc.php	(working copy)
@@ -49,7 +49,7 @@
 
 			return false;
 		}
-		$result = DBexecute('DELETE FROM hosts_groups WHERE groupid='.$groupid);
+		$result = DBexecute('DELETE FROM hosts_groups WHERE groupid='.zbx_dbstr($groupid));
 		$hosts = zbx_toObject($hosts, 'hostid');
 
 		$options = array(
@@ -79,7 +79,7 @@
 	function setHostGroupInternal($groupids, $internal=ZBX_NOT_INTERNAL_GROUP){
 		zbx_value2array($groupids);
 
-		$sql = 'UPDATE groups SET internal='.$internal.' WHERE '.DBcondition('groupid', $groupids);
+		$sql = 'UPDATE groups SET internal='.zbx_dbstr($internal).' WHERE '.DBcondition('groupid', $groupids);
 		$result = DBexecute($sql);
 	return $result;
 	}
@@ -188,7 +188,7 @@
 				' WHERE h.host='.zbx_dbstr($host).
 					' AND '.DBin_node('h.hostid', get_current_nodeid(false)).
 					' AND status IN ('.HOST_STATUS_MONITORED.','.HOST_STATUS_NOT_MONITORED.','.HOST_STATUS_TEMPLATE.')'.
-					(isset($hostid)?' AND h.hostid<>'.$hostid:'');
+					(isset($hostid)?' AND h.hostid<>'.zbx_dbstr($hostid):'');
 		if(DBfetch(DBselect($sql))){
 			error(S_HOST.SPACE.'"'.$host.'"'.SPACE.S_ALREADY_EXISTS_SMALL);
 			return false;
@@ -199,8 +199,8 @@
 			$result = DBexecute('INSERT INTO hosts '.
 				'(hostid,proxy_hostid,host,port,status,useip,dns,ip,disable_until,available,'.
 					'useipmi,ipmi_port,ipmi_authtype,ipmi_privilege,ipmi_username,ipmi_password,ipmi_ip) '.
-				' VALUES ('.$hostid.','.$proxy_hostid.','.zbx_dbstr($host).','.$port.','.$status.','.$useip.','.zbx_dbstr($dns).','.zbx_dbstr($ip).',0,'
-					.HOST_AVAILABLE_UNKNOWN.','.($useipmi === 'yes' ? 1 : 0).','.$ipmi_port.','.$ipmi_authtype.','.$ipmi_privilege.','.zbx_dbstr($ipmi_username).','
+				' VALUES ('.$hostid.','.zbx_dbstr($proxy_hostid).','.zbx_dbstr($host).','.zbx_dbstr($port).','.zbx_dbstr($status).','.zbx_dbstr($useip).','.zbx_dbstr($dns).','.zbx_dbstr($ip).',0,'
+					.HOST_AVAILABLE_UNKNOWN.','.($useipmi === 'yes' ? 1 : 0).','.zbx_dbstr($ipmi_port).','.zbx_dbstr($ipmi_authtype).','.zbx_dbstr($ipmi_privilege).','.zbx_dbstr($ipmi_username).','
 					.zbx_dbstr($ipmi_password).','.zbx_dbstr($ipmi_ip).')');
 			if($result){
 				add_audit_ext(AUDIT_ACTION_ADD, AUDIT_RESOURCE_HOST, $hostid, $host, 'hosts', NULL, NULL);
@@ -213,21 +213,21 @@
 			}
 
 			$host_old = get_host_by_hostid($hostid);
-			$result = DBexecute('UPDATE hosts SET proxy_hostid='.$proxy_hostid.
+			$result = DBexecute('UPDATE hosts SET proxy_hostid='.zbx_dbstr($proxy_hostid).
 							',host='.zbx_dbstr($host).
-							',port='.$port.
-							',status='.$status.
-							',useip='.$useip.
+							',port='.zbx_dbstr($port).
+							',status='.zbx_dbstr($status).
+							',useip='.zbx_dbstr($useip).
 							',dns='.zbx_dbstr($dns).
 							',ip='.zbx_dbstr($ip).
 							',useipmi='.($useipmi == 'yes' ? 1 : 0).
-							',ipmi_port='.$ipmi_port.
-							',ipmi_authtype='.$ipmi_authtype.
-							',ipmi_privilege='.$ipmi_privilege.
+							',ipmi_port='.zbx_dbstr($ipmi_port).
+							',ipmi_authtype='.zbx_dbstr($ipmi_authtype).
+							',ipmi_privilege='.zbx_dbstr($ipmi_privilege).
 							',ipmi_username='.zbx_dbstr($ipmi_username).
 							',ipmi_password='.zbx_dbstr($ipmi_password).
 							',ipmi_ip='.zbx_dbstr($ipmi_ip).
-				' WHERE hostid='.$hostid);
+				' WHERE hostid='.zbx_dbstr($hostid));
 
 			if($result){
 				$host_new = get_host_by_hostid($hostid);
@@ -238,7 +238,7 @@
 
 		foreach($templates as $id => $name){
 			$hosttemplateid = get_dbid('hosts_templates', 'hosttemplateid');
-			if(!$result = DBexecute('INSERT INTO hosts_templates VALUES ('.$hosttemplateid.','.$hostid.','.$id.')'))
+			if(!$result = DBexecute('INSERT INTO hosts_templates VALUES ('.$hosttemplateid.','.zbx_dbstr($hostid).','.zbx_dbstr($id).')'))
 				break;
 		}
 
@@ -323,7 +323,7 @@
 				if(isset($linked[$groupid]) && isset($linked[$groupid][$hostid])) continue;
 
 				$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-				$result = DBexecute('INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ('.$hostgroupid.','.$hostid.','.$groupid.')');
+				$result = DBexecute('INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ('.$hostgroupid.','.zbx_dbstr($hostid).','.zbx_dbstr($groupid).')');
 				if(!$result){
 					return false;
 				}
@@ -435,7 +435,7 @@
 		zbx_value2array($templateids);
 
 		$result = delete_template_elements($hostid, $templateids, $unlink_mode);
-		$result&= DBexecute('DELETE FROM hosts_templates WHERE hostid='.$hostid.' AND '.DBcondition('templateid',$templateids));
+		$result&= DBexecute('DELETE FROM hosts_templates WHERE hostid='.zbx_dbstr($hostid).' AND '.DBcondition('templateid',$templateids));
 	return $result;
 	}
 
@@ -517,7 +517,7 @@
 		}
 
 		foreach($hostids as $id => $hostid){
-			$sql='DELETE FROM hosts_groups WHERE hostid='.$hostid.' AND '.DBcondition('groupid', $groupids);
+			$sql='DELETE FROM hosts_groups WHERE hostid='.zbx_dbstr($hostid).' AND '.DBcondition('groupid', $groupids);
 			DBexecute($sql);
 		}
 
@@ -642,7 +642,7 @@
 // delete host
 		foreach ($hostids as $id) {	/* The section should be improved */
 			$host_old = get_host_by_hostid($id);
-			$result = DBexecute('DELETE FROM hosts WHERE hostid='.$id);
+			$result = DBexecute('DELETE FROM hosts WHERE hostid='.zbx_dbstr($id));
 			if ($result)
 				add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_HOST, $id, $host_old['host'], 'hosts', NULL, NULL);
 			else
@@ -734,7 +734,7 @@
 
 		foreach ($groupids as $id) {	/* The section should be improved */
 			$hostgroup_old = get_hostgroup_by_groupid($id);
-			$result = DBexecute('DELETE FROM groups WHERE groupid='.$id);
+			$result = DBexecute('DELETE FROM groups WHERE groupid='.zbx_dbstr($id));
 			if ($result)
 				add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_HOST_GROUP, $id, $hostgroup_old['name'], 'groups', NULL, NULL);
 			else
@@ -745,7 +745,7 @@
 	}
 
 	function get_hostgroup_by_groupid($groupid){
-		$result=DBselect("select * from groups where groupid=".$groupid);
+		$result=DBselect("select * from groups where groupid=".zbx_dbstr($groupid));
 		$row=DBfetch($result);
 		if($row){
 			return $row;
@@ -759,7 +759,7 @@
 
 		$result=DBselect('SELECT DISTINCT hg.groupid '.
 						' FROM hosts_groups hg '.
-						' WHERE hg.hostid='.$hostid);
+						' WHERE hg.hostid='.zbx_dbstr($hostid));
 		while($row=DBfetch($result)){
 			$groupids[$row['groupid']] = $row['groupid'];
 		}
@@ -779,7 +779,7 @@
 		else
 			$result = DBselect('SELECT * FROM hosts WHERE status IN ('.HOST_STATUS_PROXY.')'.
 					' and '.DBin_node('hostid').' AND host='.zbx_dbstr($name).
-					' and hostid<>'.$proxyid);
+					' and hostid<>'.zbx_dbstr($proxyid));
 
 		if(DBfetch($result)){
 			error(S_PROXY.SPACE."'$name'".SPACE.S_ALREADY_EXISTS_SMALL);
@@ -797,7 +797,7 @@
 			return $proxyid;
 		}
 		else
-			return DBexecute('update hosts set host='.zbx_dbstr($name).' where hostid='.$proxyid);
+			return DBexecute('update hosts set host='.zbx_dbstr($name).' where hostid='.zbx_dbstr($proxyid));
 	}
 
 	function delete_proxy($proxyids){
@@ -832,10 +832,10 @@
 	}
 
 	function update_hosts_by_proxyid($proxyid,$hosts=array()){
-		DBexecute('update hosts set proxy_hostid=0 where proxy_hostid='.$proxyid);
+		DBexecute('update hosts set proxy_hostid=0 where proxy_hostid='.zbx_dbstr($proxyid));
 
 		foreach($hosts as $hostid){
-			DBexecute('update hosts set proxy_hostid='.$proxyid.' where hostid='.$hostid);
+			DBexecute('update hosts set proxy_hostid='.zbx_dbstr($proxyid).' where hostid='.zbx_dbstr($hostid));
 		}
 	}
 
@@ -890,7 +890,7 @@
 	}
 
 	function get_host_by_hostid($hostid,$no_error_message=0){
-		$sql='SELECT * FROM hosts WHERE hostid='.$hostid;
+		$sql='SELECT * FROM hosts WHERE hostid='.zbx_dbstr($hostid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row){
@@ -928,7 +928,7 @@
 			if($status != $host['status']){
 //				$hosts[$host['hostid']] = $host['hostid'];
 				update_trigger_value_to_unknown_by_hostid($host['hostid']);
-				$res = DBexecute('UPDATE hosts SET status='.$status.' WHERE hostid='.$host['hostid']);
+				$res = DBexecute('UPDATE hosts SET status='.zbx_dbstr($status).' WHERE hostid='.zbx_dbstr($host['hostid']));
 				if($res){
 					$host_new = $host;//get_host_by_hostid($host['hostid']);
 					$host_new['status'] = $status;
@@ -971,7 +971,7 @@
 		$db_templates = DBselect('SELECT DISTINCT h.hostid,h.host '.
 				' FROM hosts_templates ht '.
 					' LEFT JOIN hosts h ON h.hostid=ht.templateid '.
-				' WHERE ht.hostid='.$hostid.
+				' WHERE ht.hostid='.zbx_dbstr($hostid).
 				' ORDER BY h.host');
 
 		while($template_data = DBfetch($db_templates)){
@@ -1511,7 +1511,7 @@
 
 		if($_REQUEST['groupid'] > 0){
 			if($_REQUEST['hostid'] > 0){
-				$sql = 'SELECT groupid FROM hosts_groups WHERE hostid='.$_REQUEST['hostid'].' AND groupid='.$_REQUEST['groupid'];
+				$sql = 'SELECT groupid FROM hosts_groups WHERE hostid='.zbx_dbstr($_REQUEST['hostid']).' AND groupid='.zbx_dbstr($_REQUEST['groupid']);
 				if(!DBfetch(DBselect($sql))){
 					$_REQUEST['hostid'] = 0;
 				}
@@ -1640,9 +1640,9 @@
 		$sql = 'SELECT applicationid
 			FROM applications
 			WHERE name='.zbx_dbstr($name).'
-				AND hostid='.$hostid;
+				AND hostid='.zbx_dbstr($hostid);
 		if(!is_null($applicationid)){
-			$sql .= ' AND applicationid<>'.$applicationid;
+			$sql .= ' AND applicationid<>'.zbx_dbstr($applicationid);
 		}
 		$db_app = DBfetch(DBselect($sql));
 
@@ -1664,15 +1664,15 @@
 			$applicationid_new = get_dbid('applications', 'applicationid');
 
 			$sql = 'INSERT INTO applications (applicationid, name, hostid, templateid) '.
-				" VALUES ($applicationid_new, ".zbx_dbstr($name).", $hostid, $templateid)";
+				" VALUES ($applicationid_new, ".zbx_dbstr($name).", ".zbx_dbstr($hostid).", ".zbx_dbstr($templateid).")";
 			if($result = DBexecute($sql)){
 				info(S_ADDED_NEW_APPLICATION.SPACE.$host['host'].':'.$name);
 			}
 		}
 		else{
 			$old_app = get_application_by_applicationid($applicationid);
-			$result = DBexecute('UPDATE applications SET name='.zbx_dbstr($name).', hostid='.$hostid.', templateid='.$templateid.
-				' WHERE applicationid='.$applicationid);
+			$result = DBexecute('UPDATE applications SET name='.zbx_dbstr($name).', hostid='.zbx_dbstr($hostid).', templateid='.zbx_dbstr($templateid).
+				' WHERE applicationid='.zbx_dbstr($applicationid));
 			if($result)
 				info(S_UPDATED_APPLICATION.SPACE.$host['host'].':'.$old_app['name']);
 		}
@@ -1805,7 +1805,7 @@
 	}
 
 	function get_application_by_applicationid($applicationid,$no_error_message=0){
-		$result = DBselect("select * from applications where applicationid=".$applicationid);
+		$result = DBselect('select * from applications where applicationid='.zbx_dbstr($applicationid));
 		$row=DBfetch($result);
 		if($row)
 		{
@@ -1818,7 +1818,7 @@
 	}
 
 	function get_applications_by_templateid($applicationid){
-		return DBselect("select * from applications where templateid=".$applicationid);
+		return DBselect('select * from applications where templateid='.zbx_dbstr($applicationid));
 	}
 
 	function get_realhost_by_applicationid($applicationid){
@@ -1830,7 +1830,7 @@
 	}
 
 	function get_host_by_applicationid($applicationid){
-		$sql="select h.* from hosts h, applications a where a.hostid=h.hostid and a.applicationid=$applicationid";
+		$sql='select h.* from hosts h, applications a where a.hostid=h.hostid and a.applicationid='.zbx_dbstr($applicationid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row)
@@ -1842,11 +1842,11 @@
 	}
 
 	function get_items_by_applicationid($applicationid){
-		return DBselect("select i.* from items i,items_applications ia where i.itemid=ia.itemid and ia.applicationid=$applicationid");
+		return DBselect("select i.* from items i,items_applications ia where i.itemid=ia.itemid and ia.applicationid=".zbx_dbstr($applicationid));
 	}
 
 	function get_applications_by_hostid($hostid){
-		return DBselect('select * from applications where hostid='.$hostid);
+		return DBselect('select * from applications where hostid='.zbx_dbstr($hostid));
 	}
 
 	/*
@@ -2006,7 +2006,7 @@
 
 	function add_host_profile($hostid,$devicetype,$name,$os,$serialno,$tag,$macaddress,$hardware,$software,$contact,$location,$notes){
 
-		$result=DBselect('SELECT * FROM hosts_profiles WHERE hostid='.$hostid);
+		$result=DBselect('SELECT * FROM hosts_profiles WHERE hostid='.zbx_dbstr($hostid));
 		if(DBfetch($result)){
 			error(S_HOST_PROFILE.SPACE.S_ALREADY_EXISTS);
 			return 0;
@@ -2047,7 +2047,7 @@
 			'poc_1_name','poc_1_email','poc_1_phone_1','poc_1_phone_2','poc_1_cell','poc_1_screen','poc_1_notes','poc_2_name',
 			'poc_2_email','poc_2_phone_1','poc_2_phone_2','poc_2_cell','poc_2_screen','poc_2_notes');
 
-		$result=DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.$hostid);
+		$result=DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($hostid));
 		if(DBfetch($result)){
 			error(S_HOST_PROFILE.SPACE.S_ALREADY_EXISTS);
 			return false;
Index: frontends/php/include/users.inc.php
===================================================================
--- frontends/php/include/users.inc.php	(revision 38884)
+++ frontends/php/include/users.inc.php	(working copy)
@@ -75,23 +75,23 @@
 
 		$sql = 'UPDATE users SET '.
 					' url='.zbx_dbstr($url).','.
-					' autologin='.$autologin.','.
-					' autologout='.$autologout.','.
+					' autologin='.zbx_dbstr($autologin).','.
+					' autologout='.zbx_dbstr($autologout).','.
 					' lang='.zbx_dbstr($lang).','.
 					' theme='.zbx_dbstr($theme).','.
 					(isset($passwd)?(' passwd='.zbx_dbstr(md5($passwd)).',') : '').
-					' refresh='.$refresh.
-				' WHERE userid='.$userid;
+					' refresh='.zbx_dbstr($refresh).
+				' WHERE userid='.zbx_dbstr($userid);
 
 		$result = DBexecute($sql);
 
-		$result = DBexecute('DELEET FROM media WHERE userid='.$userid);
+		$result = DBexecute('DELEET FROM media WHERE userid='.zbx_dbstr($userid));
 			foreach($user_medias as $mediaid => $media_data){
 				$mediaid = get_dbid("media","mediaid");
 
 				$sql = 'INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period)'.
-						' VALUES ('.$mediaid.','.$userid.','.$media_data['mediatypeid'].','.
-								zbx_dbstr($media_data['sendto']).','.$media_data['active'].','.$media_data['severity'].','.
+						' VALUES ('.$mediaid.','.zbx_dbstr($userid).','.zbx_dbstr($media_data['mediatypeid']).','.
+								zbx_dbstr($media_data['sendto']).','.zbx_dbstr($media_data['active']).','.zbx_dbstr($media_data['severity']).','.
 								zbx_dbstr($media_data['period']).')';
 
 				$result = DBexecute($sql);
@@ -122,11 +122,11 @@
 	function add_user_to_group($userid,$usrgrpid){
 		$result = false;
 		if(granted2move_user($userid,$usrgrpid)){
-			DBexecute('DELETE FROM users_groups WHERE userid='.$userid.' AND usrgrpid='.$usrgrpid);
+			DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($userid).' AND usrgrpid='.zbx_dbstr($usrgrpid));
 
 			$users_groups_id = get_dbid("users_groups","id");
 			$result = DBexecute('INSERT INTO users_groups (id,usrgrpid,userid) '.
-									' VALUES ('.$users_groups_id.','.$usrgrpid.','.$userid.')');
+									' VALUES ('.$users_groups_id.','.zbx_dbstr($usrgrpid).','.zbx_dbstr($userid).')');
 		}
 		else{
 			error(S_USER_CANNOT_CHANGE_STATUS);
@@ -137,7 +137,7 @@
 	function remove_user_from_group($userid,$usrgrpid){
 		$result = false;
 		if(granted2move_user($userid,$usrgrpid)){
-			$result = DBexecute('DELETE FROM users_groups WHERE userid='.$userid.' AND usrgrpid='.$usrgrpid);
+			$result = DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($userid).' AND usrgrpid='.zbx_dbstr($usrgrpid));
 		}
 		else{
 			error(S_USER_CANNOT_CHANGE_STATUS);
@@ -203,11 +203,11 @@
 			if(!$result)	return	$result;
 		}
 
-		$result=DBexecute("delete from rights where groupid=".$usrgrpid);
+		$result=DBexecute("delete from rights where groupid=".zbx_dbstr($usrgrpid));
 		foreach($rights as $right){
 			$id = get_dbid('rights','rightid');
 			$result=DBexecute('insert into rights (rightid,groupid,permission,id)'.
-				' values ('.$id.','.$usrgrpid.','.$right['permission'].','.$right['id'].')');
+				' values ('.$id.','.$usrgrpid.','.zbx_dbstr($right['permission']).','.zbx_dbstr($right['id']).')');
 
 			if(!$result)	return	$result;
 		}
@@ -221,14 +221,14 @@
 		$sql = 'SELECT * '.
 				' FROM usrgrp '.
 				' WHERE name='.zbx_dbstr($name).
-					' AND usrgrpid<>'.$usrgrpid.
+					' AND usrgrpid<>'.zbx_dbstr($usrgrpid).
 					' AND '.DBin_node('usrgrpid', false);
 		if(DBfetch(DBselect($sql))){
 			error(S_GROUP.SPACE.$name.SPACE.S_ALREADY_EXISTS_SMALL);
 			return 0;
 		}
 
-		$result=DBexecute('UPDATE usrgrp SET name='.zbx_dbstr($name).' WHERE usrgrpid='.$usrgrpid);
+		$result=DBexecute('UPDATE usrgrp SET name='.zbx_dbstr($name).' WHERE usrgrpid='.zbx_dbstr($usrgrpid));
 		if(!$result) return	$result;
 
 // must come before adding user to group
@@ -244,7 +244,7 @@
 			$grant = !uint_in_array($USER_DETAILS['userid'],$users);
 		}
 		if($grant){
-			$result = DBexecute('DELETE FROM users_groups WHERE usrgrpid='.$usrgrpid);
+			$result = DBexecute('DELETE FROM users_groups WHERE usrgrpid='.zbx_dbstr($usrgrpid));
 			foreach($users as $userid => $name){
 				$result = add_user_to_group($userid,$usrgrpid);
 				if(!$result)	return	$result;
@@ -255,11 +255,11 @@
 			return false;
 		}
 
-		$result=DBexecute('DELETE FROM rights WHERE groupid='.$usrgrpid);
+		$result=DBexecute('DELETE FROM rights WHERE groupid='.zbx_dbstr($usrgrpid));
 		foreach($rights as $right){
 			$id = get_dbid('rights','rightid');
 			$result = DBexecute('INSERT INTO rights (rightid,groupid,permission,id)'.
-				' VALUES ('.$id.','.$usrgrpid.','.$right['permission'].','.$right['id'].')');
+				' VALUES ('.$id.','.zbx_dbstr($usrgrpid).','.zbx_dbstr($right['permission']).','.zbx_dbstr($right['id']).')');
 
 			if(!$result)	return	$result;
 		}
@@ -291,7 +291,7 @@
 		if($users_status == GROUP_STATUS_DISABLED) $grant = granted2update_group($usrgrpids);
 
 		if($grant)
-			$res = DBexecute('UPDATE usrgrp SET users_status='.$users_status.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+			$res = DBexecute('UPDATE usrgrp SET users_status='.zbx_dbstr($users_status).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 		else
 			error(S_USER_CANNOT_CHANGE_STATUS);
 
@@ -307,7 +307,7 @@
 		if($gui_access == GROUP_GUI_ACCESS_DISABLED) $grant = granted2update_group($usrgrpids);
 
 		if($grant)
-			$res = DBexecute('UPDATE usrgrp SET gui_access='.$gui_access.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+			$res = DBexecute('UPDATE usrgrp SET gui_access='.zbx_dbstr($gui_access).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 		else
 			error(S_USER_CANNOT_CHANGE_GUI_ACCESS);
 
@@ -317,14 +317,14 @@
 	function change_group_api_access($usrgrpids, $api_access){
 		zbx_value2array($usrgrpids);
 		$res = false;
-		$res = DBexecute('UPDATE usrgrp SET api_access='.$api_access.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+		$res = DBexecute('UPDATE usrgrp SET api_access='.zbx_dbstr($api_access).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 	return $res;
 	}
 
 	function change_group_debug_mode($usrgrpids, $debug_mode){
 		zbx_value2array($usrgrpids);
 		$res = false;
-		$res = DBexecute('UPDATE usrgrp SET debug_mode='.$debug_mode.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+		$res = DBexecute('UPDATE usrgrp SET debug_mode='.zbx_dbstr($debug_mode).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 	return $res;
 	}
 ?>
Index: frontends/php/include/perm.inc.php
===================================================================
--- frontends/php/include/perm.inc.php	(revision 38884)
+++ frontends/php/include/perm.inc.php	(working copy)
@@ -24,7 +24,7 @@
 	$sessionid = md5(time().$password.$name.rand(0,10000000));
 	zbx_setcookie('zbx_sessionid',$sessionid);
 
-	DBexecute('INSERT INTO sessions (sessionid,userid,lastaccess,status) VALUES ('.zbx_dbstr($sessionid).','.$userid.','.time().','.ZBX_SESSION_ACTIVE.')');
+	DBexecute('INSERT INTO sessions (sessionid,userid,lastaccess,status) VALUES ('.zbx_dbstr($sessionid).','.zbx_dbstr($userid).','.time().','.ZBX_SESSION_ACTIVE.')');
 
 return $sessionid;
 }
@@ -77,7 +77,7 @@
 function  check_perm2system($userid){
 	$sql = 'SELECT g.usrgrpid '.
 		' FROM usrgrp g, users_groups ug '.
-		' WHERE ug.userid = '.$userid.
+		' WHERE ug.userid = '.zbx_dbstr($userid).
 			' AND g.usrgrpid = ug.usrgrpid '.
 			' AND g.users_status = '.GROUP_STATUS_DISABLED;
 	if($res = DBfetch(DBselect($sql,1))){
@@ -121,7 +121,7 @@
 
 	$sql = 'SELECT MAX(g.gui_access) as gui_access '.
 		' FROM usrgrp g, users_groups ug '.
-		' WHERE ug.userid='.$userid.
+		' WHERE ug.userid='.zbx_dbstr($userid).
 			' AND g.usrgrpid=ug.usrgrpid ';
 	$acc = DBfetch(DBselect($sql));
 
@@ -135,7 +135,7 @@
 function get_user_api_access($userid){
 	$sql = 'SELECT g.usrgrpid '.
 			' FROM usrgrp g, users_groups ug '.
-			' WHERE ug.userid = '.$userid.
+			' WHERE ug.userid = '.zbx_dbstr($userid).
 				' AND g.usrgrpid = ug.usrgrpid '.
 				' AND g.api_access = '.GROUP_API_ACCESS_ENABLED;
 	if($res = DBfetch(DBselect($sql,1))){
@@ -147,7 +147,7 @@
 function get_user_debug_mode($userid){
 	$sql = 'SELECT g.usrgrpid '.
 			' FROM usrgrp g, users_groups ug '.
-			' WHERE ug.userid = '.$userid.
+			' WHERE ug.userid = '.zbx_dbstr($userid).
 				' AND g.usrgrpid = ug.usrgrpid '.
 				' AND g.debug_mode = '.GROUP_DEBUG_MODE_ENABLED;
 	if($res = DBfetch(DBselect($sql,1))){
@@ -279,7 +279,7 @@
 			' LEFT JOIN hosts_groups hg ON hg.hostid=h.hostid '.
 			' LEFT JOIN groups g ON g.groupid=hg.groupid '.
 			' LEFT JOIN rights r ON r.id=g.groupid '.
-			' LEFT JOIN users_groups ug ON ug.usrgrpid=r.groupid and ug.userid='.$userid.
+			' LEFT JOIN users_groups ug ON ug.usrgrpid=r.groupid and ug.userid='.zbx_dbstr($userid).
 			' LEFT JOIN nodes n ON '.DBid2nodeid('h.hostid').'=n.nodeid '.
 		$where.
 		' GROUP BY h.hostid,n.nodeid,n.name,h.host,ug.userid '.
@@ -363,7 +363,7 @@
 	$sql = 'SELECT n.nodeid as nodeid,n.name as node_name,hg.groupid,hg.name,min(r.permission) as permission,g.userid'.
 		' FROM groups hg '.
 			' LEFT JOIN rights r ON r.id=hg.groupid '.
-			' LEFT JOIN users_groups g ON r.groupid=g.usrgrpid AND g.userid='.$userid.
+			' LEFT JOIN users_groups g ON r.groupid=g.usrgrpid AND g.userid='.zbx_dbstr($userid).
 			' LEFT JOIN nodes n ON '.DBid2nodeid('hg.groupid').'=n.nodeid '.
 		$where.
 		' GROUP BY n.nodeid, n.name, hg.groupid, hg.name, g.userid, g.userid '.
@@ -465,7 +465,7 @@
 	foreach($node_data as $nodeid => $node){
 		switch($perm_res){
 			case PERM_RES_DATA_ARRAY:
-				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.$nodeid.' ORDER BY name'));
+				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.zbx_dbstr($nodeid).' ORDER BY name'));
 
 				if(!ZBX_DISTRIBUTED){
 					if(!$node){
@@ -692,7 +692,7 @@
 	foreach($node_data as $nodeid => $node){
 		switch($perm_res){
 			case PERM_RES_DATA_ARRAY:
-				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.$nodeid));
+				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.zbx_dbstr($nodeid)));
 
 				if(!ZBX_DISTRIBUTED){
 					if(!$node){
Index: frontends/php/include/config.inc.php
===================================================================
--- frontends/php/include/config.inc.php	(revision 38884)
+++ frontends/php/include/config.inc.php	(working copy)
@@ -1028,13 +1028,13 @@
 	}
 /*************** VALUE MAPPING ******************/
 	function add_mapping_to_valuemap($valuemapid, $mappings){
-		DBexecute("delete FROM mappings WHERE valuemapid=$valuemapid");
+		DBexecute("delete FROM mappings WHERE valuemapid=".zbx_dbstr($valuemapid));
 
 		foreach($mappings as $map){
 			$mappingid = get_dbid("mappings","mappingid");
 
 			$result = DBexecute("insert into mappings (mappingid,valuemapid, value, newvalue)".
-				" values (".$mappingid.",".$valuemapid.",".zbx_dbstr($map["value"]).",".
+				" values (".$mappingid.",".zbx_dbstr($valuemapid).",".zbx_dbstr($map["value"]).",".
 				zbx_dbstr($map["newvalue"]).")");
 
 			if(!$result)
@@ -1066,7 +1066,7 @@
 		if(!is_array($mappings))	return FALSE;
 
 		$result = DBexecute('UPDATE valuemaps SET name='.zbx_dbstr($name).
-			' WHERE valuemapid='.$valuemapid);
+			' WHERE valuemapid='.zbx_dbstr($valuemapid));
 
 		if(!$result)
 			return $result;
@@ -1079,8 +1079,8 @@
 	}
 
 	function delete_valuemap($valuemapid){
-		DBexecute('DELETE FROM mappings WHERE valuemapid='.$valuemapid);
-		DBexecute('DELETE FROM valuemaps WHERE valuemapid='.$valuemapid);
+		DBexecute('DELETE FROM mappings WHERE valuemapid='.zbx_dbstr($valuemapid));
+		DBexecute('DELETE FROM valuemaps WHERE valuemapid='.zbx_dbstr($valuemapid));
 	return TRUE;
 	}
 
Index: frontends/php/include/audit.inc.php
===================================================================
--- frontends/php/include/audit.inc.php	(revision 38884)
+++ frontends/php/include/audit.inc.php	(working copy)
@@ -73,7 +73,7 @@
 
 		if(($result = DBexecute('INSERT INTO auditlog (auditid,userid,clock,action,resourcetype,details,ip) '.
 			' VALUES ('.$auditid.','.$USER_DETAILS['userid'].','.time().','.
-						$action.','.$resourcetype.','.zbx_dbstr($details).','.
+						zbx_dbstr($action).','.zbx_dbstr($resourcetype).','.zbx_dbstr($details).','.
 						zbx_dbstr($ip).')')))
 		{
 			$result = $auditid;
@@ -107,7 +107,7 @@
 		$ip = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_X_FORWARDED_FOR']))?$_SERVER['HTTP_X_FORWARDED_FOR']:$_SERVER['REMOTE_ADDR'];
 		$result = DBexecute('INSERT INTO auditlog (auditid,userid,clock,ip,action,resourcetype,resourceid,resourcename)'.
 				' values ('.$auditid.','.$USER_DETAILS['userid'].','.time().','.zbx_dbstr($ip).
-				','.$action.','.$resourcetype.','.$resourceid.','.zbx_dbstr($resourcename).')');
+				','.zbx_dbstr($action).','.zbx_dbstr($resourcetype).','.zbx_dbstr($resourceid).','.zbx_dbstr($resourcename).')');
 
 		if($result && $action == AUDIT_ACTION_UPDATE){
 			foreach ($values_diff as $id){
Index: frontends/php/include/discovery.inc.php
===================================================================
--- frontends/php/include/discovery.inc.php	(revision 38884)
+++ frontends/php/include/discovery.inc.php	(working copy)
@@ -144,12 +144,12 @@
 
 	function	get_discovery_rule_by_druleid($druleid)
 	{
-		return DBfetch(DBselect('select * from drules where druleid='.$druleid));
+		return DBfetch(DBselect('select * from drules where druleid='.zbx_dbstr($druleid)));
 	}
 
 	function	set_discovery_rule_status($druleid, $status)
 	{
-		return DBexecute('update drules set status='.$status.' where druleid='.$druleid);
+		return DBexecute('update drules set status='.zbx_dbstr($status).' where druleid='.zbx_dbstr($druleid));
 	}
 
 	function	add_discovery_check($druleid, $type, $ports, $key, $snmp_community,
@@ -158,9 +158,9 @@
 		$dcheckid = get_dbid('dchecks', 'dcheckid');
 		$result = DBexecute('insert into dchecks (dcheckid,druleid,type,ports,key_,snmp_community'.
 				',snmpv3_securityname,snmpv3_securitylevel,snmpv3_authpassphrase,snmpv3_privpassphrase) '.
-				' values ('.$dcheckid.','.$druleid.','.$type.','.zbx_dbstr($ports).','.
+				' values ('.$dcheckid.','.zbx_dbstr($druleid).','.zbx_dbstr($type).','.zbx_dbstr($ports).','.
 				zbx_dbstr($key).','.zbx_dbstr($snmp_community).','.zbx_dbstr($snmpv3_securityname).','.
-				$snmpv3_securitylevel.','.zbx_dbstr($snmpv3_authpassphrase).','.zbx_dbstr($snmpv3_privpassphrase).')');
+				zbx_dbstr($snmpv3_securitylevel).','.zbx_dbstr($snmpv3_authpassphrase).','.zbx_dbstr($snmpv3_privpassphrase).')');
 
 		if(!$result)
 			return $result;
@@ -176,7 +176,7 @@
 
 		$druleid = get_dbid('drules', 'druleid');
 		$result = DBexecute('insert into drules (druleid,proxy_hostid,name,iprange,delay,status) '.
-			' values ('.$druleid.','.$proxy_hostid.','.zbx_dbstr($name).','.zbx_dbstr($iprange).','.$delay.','.$status.')');
+			' values ('.$druleid.','.zbx_dbstr($proxy_hostid).','.zbx_dbstr($name).','.zbx_dbstr($iprange).','.zbx_dbstr($delay).','.zbx_dbstr($status).')');
 
 		if($result && isset($dchecks)){
 			$unique_dcheckid = 0;
@@ -188,8 +188,8 @@
 					$unique_dcheckid = $data['dcheckid'];
 			}
 			DBexecute('UPDATE drules'.
-					' SET unique_dcheckid='.$unique_dcheckid.
-					' WHERE druleid='.$druleid);
+					' SET unique_dcheckid='.zbx_dbstr($unique_dcheckid).
+					' WHERE druleid='.zbx_dbstr($druleid));
 
 			$result = $druleid;
 		}
@@ -204,8 +204,8 @@
 
 		}
 
-		$result = DBexecute('update drules set proxy_hostid='.$proxy_hostid.',name='.zbx_dbstr($name).',iprange='.zbx_dbstr($iprange).','.
-			'delay='.$delay.',status='.$status.' where druleid='.$druleid);
+		$result = DBexecute('update drules set proxy_hostid='.zbx_dbstr($proxy_hostid).',name='.zbx_dbstr($name).',iprange='.zbx_dbstr($iprange).','.
+			'delay='.zbx_dbstr($delay).',status='.zbx_dbstr($status).' where druleid='.zbx_dbstr($druleid));
 
 		if($result && isset($dchecks))
 		{
@@ -220,8 +220,8 @@
 					$unique_dcheckid = $data['dcheckid'];
 			}
 			DBexecute('UPDATE drules'.
-					' SET unique_dcheckid='.$unique_dcheckid.
-					' WHERE druleid='.$druleid);
+					' SET unique_dcheckid='.zbx_dbstr($unique_dcheckid).
+					' WHERE druleid='.zbx_dbstr($druleid));
 		}
 
 		if($result && isset($dchecks_deleted) && !empty($dchecks_deleted))
@@ -269,7 +269,7 @@
 		$sql = 'SELECT DISTINCT actionid '.
 				' FROM conditions '.
 				' WHERE conditiontype='.CONDITION_TYPE_DRULE.
-					" AND value='$druleid'";
+					' AND value='.zbx_dbstr($druleid);
 
 		$db_actions = DBselect($sql);
 		while($db_action = DBfetch($db_actions))
@@ -285,12 +285,12 @@
 // delete action conditions
 			DBexecute('DELETE FROM conditions '.
 					' WHERE conditiontype='.CONDITION_TYPE_DRULE.
-					" AND value='$druleid'");
+					" AND value=".zbx_dbstr($druleid));
 		}
 
 		if ($result) {
 			$db_dhosts = DBselect('select dhostid from dhosts'.
-					' where druleid='.$druleid.' and '.DBin_node('dhostid'));
+					' where druleid='.zbx_dbstr($druleid).' and '.DBin_node('dhostid'));
 
 			while ($result && ($db_dhost = DBfetch($db_dhosts)))
 				$result = DBexecute('delete from dservices where'.
@@ -298,13 +298,13 @@
 		}
 
 		if ($result)
-			$result = DBexecute('delete from dhosts where druleid='.$druleid);
+			$result = DBexecute('delete from dhosts where druleid='.zbx_dbstr($druleid));
 
 		if ($result)
-			$result = DBexecute('delete from dchecks where druleid='.$druleid);
+			$result = DBexecute('delete from dchecks where druleid='.zbx_dbstr($druleid));
 
 		if ($result)
-			$result = DBexecute('delete from drules where druleid='.$druleid);
+			$result = DBexecute('delete from drules where druleid='.zbx_dbstr($druleid));
 
 		return $result;
 	}
